## eurephia 1.0.1

=== CMakeLists.txt ===
#  cmake rules for eurephia - main file
#
#  GPLv2 only - Copyright (C) 2008 - 2010
#               David Sommerseth <dazo@users.sourceforge.net>
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; version 2
#  of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
PROJECT(eurephia C)
cmake_minimum_required(VERSION 2.6)

# Set the eurephia version
ADD_DEFINITIONS(-DEUREPHIAVERSION="1.0.1")

# eurephia parameters - boolean values
OPTION(DEBUG "Add more verbose debug information" OFF)
OPTION(SHOW_SECRETS "Show passwords as clear text in logs." OFF)
OPTION(SQLITE3 "Build database driver for SQLite3" OFF)
OPTION(EUREPHIADM "Build command line based admin utility" OFF)
OPTION(PLUGIN "Build the eurephia plugin for OpenVPN" OFF)
OPTION(DOXYGEN "Compile Doxygen documentation" OFF)

# eurephia parameters - string values
SET(OPENVPN_SRC "" CACHE STRING "Path to OpenVPN source code")
SET(PREFIX "/usr/local" CACHE STRING "Install prefix for eurephia")
SET(BINDIR "/usr/local/bin" CACHE STRING "Directory for eurephia binaries")
SET(PLUGINDIR "/usr/local/lib/eurephia" CACHE STRING "Plug-in path for the eurephia modules")
SET(XSLTROOT "/usr/local/share/eurephia/xslt" CACHE STRING "Root path for the XSLT templates")
SET(MANDIR "/usr/local/share/man" CACHE STRING "Path where to install man pages")

# Set install prefix
SET(CMAKE_INSTALL_PREFIX ${PREFIX})

# Default C compiler flags
SET(CMAKE_C_FLAGS "${CFLAGS}")

# Needed cmake modules
INCLUDE(CheckIncludeFile)
INCLUDE(CheckLibraryExists)
FIND_PACKAGE(PkgConfig)

#
# Add support for extra eurephia modules
#

# Database drivers
IF(SQLITE3)
        message(STATUS "Will build database interface for SQLite")
        SET(DATABASE ON)
        # Add the sqlite3 database driver to the build queue
        SET(subdirs ${subdirs} database/sqlite)
ENDIF(SQLITE3)

# Make sure we build at least one database driver
IF(NOT DATABASE AND (EUREPHIADM OR PLUGIN))
       message(FATAL_ERROR "Cannot build eurephia without any database drivers.")
ENDIF(NOT DATABASE AND (EUREPHIADM OR PLUGIN))


# eurephiadm - console based admin utility
IF(EUREPHIADM) 
        message(STATUS "Will build command line based admin utility")
        SET(ADMIN_ENABLED on)
        ADD_DEFINITIONS(-DENABLE_EUREPHIADM)
        # Add the eurephiadm utility to the build queue
        SET(subdirs ${subdirs} eurephiadm utils)
ENDIF(EUREPHIADM)

# Enable firewall features if iptables is enabled
IF(FW_IPTABLES)
        SET(FIREWALL on)
ENDIF(FW_IPTABLES)

# Extra checks when the openvpn plug-in is enabled
IF(PLUGIN)
        IF(NOT OPENVPN_SRC)
	       message(FATAL_ERROR "Missing path to OpenVPN source - try running ./configure again")
       ENDIF(NOT OPENVPN_SRC)
       message(STATUS "Building eurephia plug-in for OpenVPN")

       SET(CHECK_INCL_FILE "${OPENVPN_SRC}/openvpn-plugin.h")
       IF(NOT EXISTS ${CHECK_INCL_FILE})
              message(FATAL_ERROR "Missing openvpn-plugin.h ... Is the OpenVPN source code really located here? ${OPENVPN_SRC}")
       ENDIF(NOT EXISTS ${CHECK_INCL_FILE})

       INCLUDE_DIRECTORIES(BEFORE ${OPENVPN_SRC} .)
       # Add the openvpn plug-in to the build queue
       SET(subdirs ${subdirs} plugin)
ENDIF(PLUGIN)

#
# Check for some standard glibc functions which we need
#

# Check that we have dynamic loader available
CHECK_INCLUDE_FILE(dlfcn.h HAVE_DLFCN_H)
CHECK_LIBRARY_EXISTS(dl dlopen "" HAVE_DLOPEN)
CHECK_LIBRARY_EXISTS(dl dlclose "" HAVE_DLCLOSE)
IF(NOT HAVE_DLOPEN OR NOT HAVE_DLCLOSE)
	message(FATAL_ERROR "Missing proper dl library")
ENDIF(NOT HAVE_DLOPEN OR NOT HAVE_DLCLOSE)

# Check that we have some pthread functions
CHECK_INCLUDE_FILE(pthread.h HAVE_PTHREAD_H)
CHECK_LIBRARY_EXISTS(pthread pthread_mutex_lock "" HAVE_PTHREAD_MUTEX_LOCK)
CHECK_LIBRARY_EXISTS(pthread pthread_mutex_unlock "" HAVE_PTHREAD_MUTEX_UNLOCK)
IF(NOT HAVE_PTHREAD_MUTEX_LOCK OR NOT HAVE_PTHREAD_MUTEX_UNLOCK)
	message(FATAL_ERROR "Missing proper pthread_mutex support")
ENDIF(NOT HAVE_PTHREAD_MUTEX_LOCK OR NOT HAVE_PTHREAD_MUTEX_UNLOCK)

#
# Check for other needed modules
#

# Check for openssl ... needed for gathering safe random data
pkg_search_module(OPENSSL REQUIRED openssl)
CHECK_LIBRARY_EXISTS(crypto RAND_load_file "" HAVE_OPENSSL_RAND_LOAD_FILE)
CHECK_LIBRARY_EXISTS(crypto RAND_pseudo_bytes "" HAVE_OPENSSL_RAND_PSEUDO_BYTES)
IF(NOT HAVE_OPENSSL_RAND_LOAD_FILE OR NOT HAVE_OPENSSL_RAND_PSEUDO_BYTES)
	message(FATAL_ERROR "Missing OpenSSL crypto support")
ENDIF(NOT HAVE_OPENSSL_RAND_LOAD_FILE OR NOT HAVE_OPENSSL_RAND_PSEUDO_BYTES)


# Generic checks when administration utilities are enabled
IF(ADMIN_ENABLED)
       # Check for libxml2
       pkg_search_module(LIBXML2 REQUIRED libxml-2.0 libxml2 libxml>=2.6)
       INCLUDE_DIRECTORIES(BEFORE  ${LIBXML2_INCLUDE_DIRS})
       ADD_DEFINITIONS(-DHAVE_LIBXML2)
       SET(EXTRA_LIBS ${EXTRA_LIBS} ${LIBXML2_LIBRARIES})

       # Check for libxslt
       pkg_search_module(LIBXSLT REQUIRED libxslt)
       INCLUDE_DIRECTORIES(BEFORE  ${LIBXSLT_INCLUDE_DIRS})
       ADD_DEFINITIONS(-DHAVE_LIBXSLT)
       SET(EXTRA_LIBS ${EXTRA_LIBS} ${LIBXSLT_LIBRARIES})

       # Find optional package for eurephiadm - OpenSSL.
       # Used for parsing certificate files, and we need a fairly
       # new openssl version.
       pkg_search_module(OPENSSL OPTIONAL openssl>=0.9.8)
       IF(OPENSSL_FOUND)
              ADD_DEFINITIONS(-DHAVE_OPENSSL)
              SET(EXTRA_LIBS ${EXTRA_LIBS} ${OPENSSL_LIBRARIES})
       ENDIF(OPENSSL_FOUND)
ENDIF(ADMIN_ENABLED)

# Export our internal common library
ADD_LIBRARY(common STATIC IMPORTED)
SET_PROPERTY(TARGET common PROPERTY IMPORTED_LOCATION ${CMAKE_SOURCE_DIR}/common/libeurephiacommon.a)

# Start the building.  First build the common library, and then the requested eurephia modules
IF(DATABASE OR PLUGIN OR FIREWALL OR EUREPHIADM)
        SUBDIRS(common ${subdirs})
ENDIF(DATABASE OR PLUGIN OR FIREWALL OR EUREPHIADM)

# Compile Doxygen docs at the end if requested
IF(DOXYGEN)
        SUBDIRS(doxygen)
ENDIF(DOXYGEN)

#  Give warning if DEBUG is enabled
IF(DEBUG)
        message(STATUS "***** DEBUG enabled ***** might be a security issue")
	ADD_DEFINITIONS(-DENABLE_DEBUG)
	IF(SHOW_SECRETS)
                message(STATUS "SHOW_SECRETS ENABLED -- THIS WILL LOG PASSWORDS IN CLEAR TEXT")
		ADD_DEFINITIONS(-DSHOW_SECRETS)
	ENDIF(SHOW_SECRETS)
ENDIF(DEBUG)

# Install generic man pages
INSTALL(FILES man/eurephia-variables.7 DESTINATION ${MANDIR}/man7)

=== common/CMakeLists.txt ===
#  cmake rules for eurephia - common static library
#
#  GPLv2 only - Copyright (C) 2008 - 2010
#               David Sommerseth <dazo@users.sourceforge.net>
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; version 2
#  of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
PROJECT(eurephiaCOMMON C)
cmake_minimum_required(VERSION 2.6)

# Compiler settigns
INCLUDE_DIRECTORIES(. ../database)

# Only compile these files if we have libxml2
SET(add_xml_code "")
IF(LIBXML2_FOUND)
        SET(add_xml_code
             eurephia_xml.c
             ../database/eurephiadb_mapping.c
	)
ENDIF(LIBXML2_FOUND)


#
# Create a static library
#
# Will contain all common functions used by most of the
# eurephia modules
#
ADD_LIBRARY( eurephiacommon STATIC
             certinfo.c
             eurephia_getsym.c
             eurephia_log.c
             eurephia_nullsafe.c
             eurephia_values.c
             passwd.c
             randstr.c
             sha512.c
             ../database/eurephiadb.c
             ${add_xml_code}
)

# Output name will be libeurephiacommon.a
SET_TARGET_PROPERTIES( eurephiacommon PROPERTIES COMPILE_FLAGS -fPIC)

=== doxygen/CMakeLists.txt ===
#  cmake rules for eurephia - doxygen documentation
#
#  GPLv2 only - Copyright (C) 2009 - 2010
#               David Sommerseth <dazo@users.sourceforge.net>
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; version 2
#  of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
PROJECT(eurephia-devel-docs C)
cmake_minimum_required(VERSION 2.6)

IF(DOXYGEN)
        FIND_PACKAGE(Doxygen)
        IF(NOT DOXYGEN_FOUND)
               MESSAGE(FATAL_ERROR "Could not find doxygen")
        ENDIF(NOT DOXYGEN_FOUND)
        ADD_CUSTOM_TARGET(devel-docs ALL ${DOXYGEN_EXECUTABLE} Doxygen.conf)
        SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES doxygen.log)
ENDIF(DOXYGEN)

=== eurephiadm/CMakeLists.txt ===
#  cmake rules for eurephia - eurephiadm, console admin utility
#
#  GPLv2 only - Copyright (C) 2008 - 2010
#               David Sommerseth <dazo@users.sourceforge.net>
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; version 2
#  of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
PROJECT(eurephiadm C)
cmake_minimum_required(VERSION 2.6)

# Compiler settings
INCLUDE_DIRECTORIES(../common ../database)

# eurephiadm parameters
SET(EUREPHIADM_XSLT_PATH "${XSLTROOT}/eurephiadm/" CACHE STRING "Path for eurephiadm XSLT templates")
ADD_DEFINITIONS(-DEUREPHIADM_XSLT_PATH="${EUREPHIADM_XSLT_PATH}")

IF(FIREWALL)
        ADD_DEFINITIONS(-DFIREWALL)
ENDIF(FIREWALL)

# Build rules for eurephiadm
ADD_EXECUTABLE(eurephiadm
        eurephiadm.c
        argparser.c
        get_console_input.c
        client_config.c
        client_context.c
        client_session.c
        parse_certificate_files.c
        xsltparser.c
        commands/users.c
        commands/lastlog.c
        commands/attempts.c
        commands/blacklist.c
        commands/certificates.c
        commands/usercerts.c
        commands/adminaccess.c
        commands/edit_config.c
        commands/fwprofiles.c
        ../common/eurephiadb_session_common.c
)

# Man pages to install
SET(MAN_PAGES
  man/eurephiadm.7
  man/eurephiadm-adminaccess.7
  man/eurephiadm-attempts.7
  man/eurephiadm-blacklist.7
  man/eurephiadm-certs.7
  man/eurephiadm-config.7
  man/eurephiadm-fwprofiles.7
  man/eurephiadm-lastlog.7
  man/eurephiadm-usercerts.7
  man/eurephiadm-users.7
)

# Link in the following dynamic libraries with eurephiadm.
# ${EXTRA_LIBS} contains libxml2, libxslt and openssl library names
TARGET_LINK_LIBRARIES(eurephiadm dl crypto common ${EXTRA_LIBS})

# Install rules for eurephiadm
INSTALL(TARGETS eurephiadm RUNTIME DESTINATION ${BINDIR})
INSTALL(FILES ${MAN_PAGES} DESTINATION ${MANDIR}/man7)

# Also run the rules for the XSLT templates eurephiadm needs
SUBDIRS(../xslt/eurephiadm)

=== plugin/CMakeLists.txt ===
#  cmake rules for eurephia - OpenVPN authentication plugin
#
#  GPLv2 only - Copyright (C) 2008 - 2010
#               David Sommerseth <dazo@users.sourceforge.net>
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; version 2
#  of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
PROJECT(eurephia-auth C)
cmake_minimum_required(VERSION 2.6)

# Check for POSIX semaphore functions which we use
CHECK_LIBRARY_EXISTS(rt sem_wait "" HAVE_SEM_WAIT)
CHECK_LIBRARY_EXISTS(rt sem_timedwait "" HAVE_SEM_TIMEDWAIT)
CHECK_LIBRARY_EXISTS(rt sem_post "" HAVE_SEM_POST)

# Extra checks if sem_* functions is not found in librt, do not accept failures
IF(NOT HAVE_SEM_WAIT)
       message(STATUS "* sem_wait was not found in librt, trying libpthread")
       CHECK_LIBRARY_EXISTS(pthread sem_wait "" HAVE_SEM_WAIT2)
       IF(NOT HAVE_SEM_WAIT2)
              message(FATAL_ERROR "Missing proper pthread semaphore support")
       ENDIF(NOT HAVE_SEM_WAIT2)
ENDIF(NOT HAVE_SEM_WAIT)

IF(NOT HAVE_SEM_TIMEDWAIT)
       message(STATUS "* sem_timedwait was not found in librt, trying libpthread")
       CHECK_LIBRARY_EXISTS(pthread sem_timedwait "" HAVE_SEM_TIMEDWAIT2)
       IF(NOT HAVE_SEM_TIMEDWAIT2)
              message(FATAL_ERROR "Missing proper pthread semaphore support")
       ENDIF(NOT HAVE_SEM_TIMEDWAIT2)
ENDIF(NOT HAVE_SEM_TIMEDWAIT)

IF(NOT HAVE_SEM_POST)
       message(STATUS "* sem_post was not found in librt, trying libpthread")
       CHECK_LIBRARY_EXISTS(pthread sem_post "" HAVE_SEM_POST2)
       IF(NOT HAVE_SEM_POST2)
              message(FATAL_ERROR "Missing proper pthread semaphore support")
       ENDIF(NOT HAVE_SEM_POST2)
ENDIF(NOT HAVE_SEM_POST)

# Check for POSIX MQ functions which we use
CHECK_LIBRARY_EXISTS(rt mq_open "" HAVE_RT_MQ_OPEN)
CHECK_LIBRARY_EXISTS(rt mq_close "" HAVE_RT_MQ_CLOSE)
CHECK_LIBRARY_EXISTS(rt mq_unlink "" HAVE_RT_MQ_UNLINK)
CHECK_LIBRARY_EXISTS(rt mq_send "" HAVE_RT_MQ_SEND)
CHECK_LIBRARY_EXISTS(rt mq_receive "" HAVE_RT_MQ_RECEIVE)
CHECK_LIBRARY_EXISTS(rt mq_getattr "" HAVE_RT_MQ_GETATTR)

# Fail if we're missing some features - Posix Message Queue functions
IF(NOT HAVE_RT_MQ_OPEN OR NOT HAVE_RT_MQ_CLOSE OR NOT HAVE_RT_MQ_UNLINK OR NOT HAVE_RT_MQ_SEND OR NOT HAVE_RT_MQ_RECEIVE OR NOT HAVE_RT_MQ_GETATTR)
	message(FATAL_ERROR "Missing proper pthread message queue support")
ENDIF(NOT HAVE_RT_MQ_OPEN OR NOT HAVE_RT_MQ_CLOSE OR NOT HAVE_RT_MQ_UNLINK OR NOT HAVE_RT_MQ_SEND OR NOT HAVE_RT_MQ_RECEIVE OR NOT HAVE_RT_MQ_GETATTR)


# Compiler settings
INCLUDE_DIRECTORIES(../common ../database ./firewall .)


# Do build in subdirs, if some extra modules are enabled
SET(subdirs "")
IF(FW_IPTABLES)
	# iptables module support
        message(STATUS "Will build iptables firewall module")
       SET(subdirs firewall/iptables)
ENDIF(FW_IPTABLES)


# Avoid adding administration features into the openvpn plug-in
IF(ENABLE_EUREPHIADM)
       REMOVE_DEFINITIONS(-DENABLE_EUREPHIADM)
ENDIF(ENABLE_EUREPHIADM)


# Build rule for eurephia-auth.so
ADD_LIBRARY(eurephia-auth MODULE
	eurephia-auth.c
	eurephia.c
	eurephiadb_session.c
        environment.c
        firewall/eurephiafw.c
        firewall/eurephiafw_helpers.c
        ../common/eurephiadb_session_common.c
)
SET_TARGET_PROPERTIES(eurephia-auth PROPERTIES PREFIX "")

# Link in libraries
TARGET_LINK_LIBRARIES(eurephia-auth dl pthread rt crypto common)

# Install rules
INSTALL(TARGETS eurephia-auth  LIBRARY DESTINATION ${PLUGINDIR})
INSTALL(FILES eurephia-auth.7 DESTINATION ${MANDIR}/man7)

# If subdirs contains more directories with build/install rules, do that
IF(subdirs)
        ADD_SUBDIRECTORY(${subdirs})
ENDIF(subdirs)

=== utils/CMakeLists.txt ===
#  cmake rules for eurephia - utilities
#
#  GPLv2 only - Copyright (C) 2008 - 2010
#               David Sommerseth <dazo@users.sourceforge.net>
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; version 2
#  of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
PROJECT(eurephia_utils C)
cmake_minimum_required(VERSION 2.6)

#
# Only build these tools if the eurephiadm utility will be built
#
IF(EUREPHIADM)
  # Compiler settings
  INCLUDE_DIRECTORIES(../common ../database ../eurephiadm)

  # Add the needed eurephia defines
  ADD_DEFINITIONS(-DPLUGINDIR="${PLUGINDIR}")
  IF(FW_IPTABLES)
        ADD_DEFINITIONS(-DFW_IPTABLES)
  ENDIF(FW_IPTABLES)

  # Define the eurephia_init build
  ADD_EXECUTABLE(eurephia_init
		 eurephia_init.c
                 benchmark.c
                 ../eurephiadm/get_console_input.c
                 ../eurephiadm/argparser.c
                 ../eurephiadm/client_context.c
		)
  TARGET_LINK_LIBRARIES(eurephia_init dl crypto common ${EXTRA_LIBS})

  # Define the saltdecode build
  ADD_EXECUTABLE(eurephia_saltdecode
                 eurephia_saltdecode.c
		 ../eurephiadm/get_console_input.c)
ENDIF(EUREPHIADM)

=== database/sqlite/CMakeLists.txt ===
#  cmake rules for eurephia - SQLite3 database driver
#
#  GPLv2 only - Copyright (C) 2008 - 2010
#               David Sommerseth <dazo@users.sourceforge.net>
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; version 2
#  of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
PROJECT(edb-sqlite C)
cmake_minimum_required(VERSION 2.6)
INCLUDE(CheckIncludeFile) 
INCLUDE(CheckLibraryExists) 

# Parameters the SQLite3 driver needs
SET(SQLITE3PREFIX "/etc/openvpn" CACHE STRING "Install prefix for the eurephia SQLite3 database")

#
#  Check for the SQLite3 library
#
find_package(PkgConfig)
pkg_search_module(SQLITE3 REQUIRED sqlite3)

FIND_PROGRAM(SQLITE3BIN sqlite3 /usr)
IF(NOT SQLITE3BIN)
       MESSAGE(STATUS "sqlite3 binary was not found.  You will need to generate the database file on your own")
ENDIF(NOT SQLITE3BIN)

#
#  Source files
#
SET(edb_sqlite_SRC
	sqlite.c
	edb-sqlite.c
        ../../common/eurephiadb_session_common.c
)

IF(ADMIN_ENABLED)
       SET(edb_sqlite_SRC ${edb_sqlite_SRC}
               administration/authentication.c
               administration/firewalladmin.c
               administration/attempts.c
               administration/blacklist.c
               administration/usercerts.c
               administration/configuration.c
               administration/useraccount.c
               administration/certificates.c
               administration/lastlog.c
       )
ENDIF(ADMIN_ENABLED)

# Compiler settings
ADD_DEFINITIONS(-D_GNU_SOURCE)
INCLUDE_DIRECTORIES(BEFORE ../../common/ ../../plugin/ ../../plugin/firewall ../)

#
# Build instructions
#
ADD_LIBRARY(edb-sqlite SHARED ${edb_sqlite_SRC})
TARGET_LINK_LIBRARIES(edb-sqlite common)
SET_TARGET_PROPERTIES( edb-sqlite PROPERTIES COMPILE_FLAGS -fPIC)

IF(SQLITE3BIN)
         ADD_CUSTOM_COMMAND(TARGET edb-sqlite POST_BUILD
                            COMMAND rm -f eurephiadb
                            COMMAND ${SQLITE3BIN} eurephiadb < sql-schema.sql
                                    COMMENT "Creating template database: eurephiadb")
ENDIF(SQLITE3BIN)

IF(FIREWALL)
         ADD_DEFINITIONS(-DFIREWALL)
ENDIF(FIREWALL)

TARGET_LINK_LIBRARIES(edb-sqlite sqlite3 ${EXTRA_LIBS})
ADD_DEFINITIONS(-DDRIVER_MODE)
ADD_DEFINITIONS(${LIBXML2_DEFINITIONS})
SET_TARGET_PROPERTIES(edb-sqlite PROPERTIES OUTPUT_NAME edb-sqlite PREFIX "")
SET_SOURCE_FILES_PROPERTIES(${common_files_SRC} PROPERTIES GENERATED true)
SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES eurephiadb)

#
# Install instructions
#
INSTALL(TARGETS edb-sqlite LIBRARY DESTINATION ${PLUGINDIR})
INSTALL(FILES edb-sqlite.7 DESTINATION ${MANDIR}/man7)
IF(SQLITE3BIN)
  INSTALL(FILES eurephiadb DESTINATION ${SQLITE3PREFIX}/ RENAME eurephiadb-template)
ENDIF(SQLITE3BIN)

=== xslt/eurephiadm/CMakeLists.txt ===
#  cmake rules for eurephia - XSLT templates for eurephiadm
#
#  GPLv2 only - Copyright (C) 2008 - 2010
#               David Sommerseth <dazo@users.sourceforge.net>
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; version 2
#  of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#

#
# XSLT templates to be installed together with eurephiadm
#
SET(eurephiadm_XSLT
      adminaccess.xsl
      certificates.xsl
      fwadmin.xsl
      lastlog.xsl
      usercerts.xsl
      users.xsl
      attempts.xsl
      blacklist.xsl
)
INSTALL(FILES ${eurephiadm_XSLT} DESTINATION ${EUREPHIADM_XSLT_PATH}/)

=== plugin/firewall/iptables/CMakeLists.txt ===
#  cmake rules for eurephia - iptables firewall driver
#
#  GPLv2 only - Copyright (C) 2008 - 2010
#               David Sommerseth <dazo@users.sourceforge.net>
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; version 2
#  of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
PROJECT(efw-iptables C)
cmake_minimum_required(VERSION 2.6)

# Compiler settings
INCLUDE_DIRECTORIES(BEFORE ../..)

# Build rules for efw-iptables.so
ADD_LIBRARY(efw-iptables MODULE
	 efw-iptables.c
	../eurephiafw_helpers.c
)

# Link in pthread, rt, gcc_s and our common library (libeurephiacommon.a)
TARGET_LINK_LIBRARIES(efw-iptables pthread rt gcc_s common)

# Define output to be efw-iptables.so
SET_TARGET_PROPERTIES(efw-iptables PROPERTIES PREFIX "")

# Install rules
INSTALL(TARGETS efw-iptables LIBRARY DESTINATION ${PLUGINDIR})

=== debian/changelog ===
eurephia (1.0.1-3) unstable; urgency=low

  * debian/rules: Removed configure dependency in clean target.
    Thanks Fabrice Coutadeur for pointing out. (Closes: #607247)
  * Added patch by Fabrice Coutadeur to fix FTBFS with binutils-gold.
    (Closes: #607246)

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Fri, 17 Dec 2010 18:29:51 +0100

eurephia (1.0.1-2) unstable; urgency=low

  * Upstream patch to fix daemonizing issues.

  [ Dario Minucci ]
  * Added debian/watch
  * debian/control: Added Homepage field
  * Fixed manpage-has-bad-whatis-entry lintian error.
  * Fixed some typos

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Tue, 30 Nov 2010 06:19:05 +0100

eurephia (1.0.1-1) unstable; urgency=low

  * Initial release (Closes: #600604)

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Mon, 18 Oct 2010 13:37:12 +0200

=== debian/control ===
Source: eurephia
Section: net
Priority: extra
Maintainer: Alberto Gonzalez Iniesta <agi@inittab.org>
Build-Depends: debhelper (>= 8), openvpn (>=2), cmake, libssl-dev, libxslt1-dev, libxml2-dev, libsqlite3-dev, pkg-config
Standards-Version: 3.9.1
Homepage: http://www.eurephia.net/

Package: eurephia
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openvpn (>=2)
Recommends: sqlite3
Description: flexible OpenVPN authentication module
 This plug-in enhances OpenVPN by adding user name and password authentication.
 An eurephia user account is a combination of minimum one OpenVPN SSL
 certificate and a user name with a password assigned. It is also possible to
 setup several eurephia user names to use a shared OpenVPN certificate.
 .
 In addition, eurephia will blacklist IP addresses, certificates and user names
 on too many failed attempts and it supports dynamic update of iptables rules
 which restricts network access per connection.
 .
 All information is stored in a database and all changes to the accounts will
 be effective immediately. At the moment eurephia supports the SQLite database.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	./configure --prefix /usr --plug-in --fw-iptables --db-sqlite3 --sqlite3-path /var/lib/eurephia --eurephiadm --openvpn-src /usr/include/openvpn
	touch configure-stamp

build: configure-stamp build-stamp

build-stamp:
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	
	rm -rf configure.log
	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) distclean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) install DESTDIR=$(CURDIR)/debian/eurephia
	install -p -m 755 utils/eurephia_init $(CURDIR)/debian/eurephia/usr/bin/
	install -p -m 755 utils/eurephia_saltdecode $(CURDIR)/debian/eurephia/usr/bin/
	rm -f debian/eurephia/var/lib/eurephia/eurephiadb-template

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdebconf
	dh_installdocs
	dh_installexamples
	dh_installman
	dh_installinfo
	dh_installchangelogs 
	dh_link
	dh_strip
	dh_compress -Xsql-schema.sql
	dh_fixperms
#       dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## eurephia 1.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  cmake rules for eurephia - main file
 #
-#  GPLv2 only - Copyright (C) 2008 - 2010
+#  GPLv2 only - Copyright (C) 2008 - 2012
 #               David Sommerseth <dazo@users.sourceforge.net>
 #
 #  This program is free software; you can redistribute it and/or
@@ -21,7 +21,7 @@
 cmake_minimum_required(VERSION 2.6)
 
 # Set the eurephia version
-ADD_DEFINITIONS(-DEUREPHIAVERSION="1.0.1")
+ADD_DEFINITIONS(-DEUREPHIAVERSION="1.1.0")
 
 # eurephia parameters - boolean values
 OPTION(DEBUG "Add more verbose debug information" OFF)
@@ -49,6 +49,8 @@
 INCLUDE(CheckIncludeFile)
 INCLUDE(CheckLibraryExists)
 FIND_PACKAGE(PkgConfig)
+
+MESSAGE(STATUS "Build Platform: ${CMAKE_SYSTEM_NAME}")
 
 #
 # Add support for extra eurephia modules
@@ -103,10 +105,25 @@
 # Check for some standard glibc functions which we need
 #
 
+# Check that we have enidan.h
+CHECK_INCLUDE_FILE(endian.h HAVE_ENDIAN_H)
+IF(NOT HAVE_ENDIAN_H)
+       CHECK_INCLUDE_FILE(sys/endian.h HAVE_SYS_ENDIAN_H)
+       ADD_DEFINITIONS(-DHAVE_SYS_ENDIAN_H)
+ENDIF(NOT HAVE_ENDIAN_H)
+IF(NOT HAVE_ENDIAN_H AND NOT HAVE_SYS_ENDIAN_H)
+       message(FATAL_ERROR "Missing endian.h")
+ENDIF(NOT HAVE_ENDIAN_H AND NOT HAVE_SYS_ENDIAN_H)
+
 # Check that we have dynamic loader available
 CHECK_INCLUDE_FILE(dlfcn.h HAVE_DLFCN_H)
-CHECK_LIBRARY_EXISTS(dl dlopen "" HAVE_DLOPEN)
-CHECK_LIBRARY_EXISTS(dl dlclose "" HAVE_DLCLOSE)
+IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+        CHECK_LIBRARY_EXISTS(dl dlopen "" HAVE_DLOPEN)
+        CHECK_LIBRARY_EXISTS(dl dlclose "" HAVE_DLCLOSE)
+ELSE(!${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+        CHECK_LIBRARY_EXISTS(c dlopen "" HAVE_DLOPEN)
+        CHECK_LIBRARY_EXISTS(c dlclose "" HAVE_DLCLOSE)
+ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
 IF(NOT HAVE_DLOPEN OR NOT HAVE_DLCLOSE)
 	message(FATAL_ERROR "Missing proper dl library")
 ENDIF(NOT HAVE_DLOPEN OR NOT HAVE_DLCLOSE)
@@ -137,12 +154,14 @@
        # Check for libxml2
        pkg_search_module(LIBXML2 REQUIRED libxml-2.0 libxml2 libxml>=2.6)
        INCLUDE_DIRECTORIES(BEFORE  ${LIBXML2_INCLUDE_DIRS})
+       LINK_DIRECTORIES(${LIBXML2_LIBRARY_DIRS})
        ADD_DEFINITIONS(-DHAVE_LIBXML2)
        SET(EXTRA_LIBS ${EXTRA_LIBS} ${LIBXML2_LIBRARIES})
 
        # Check for libxslt
        pkg_search_module(LIBXSLT REQUIRED libxslt)
        INCLUDE_DIRECTORIES(BEFORE  ${LIBXSLT_INCLUDE_DIRS})
+       LINK_DIRECTORIES(${LIBXSLT_LIBRARY_DIRS})
        ADD_DEFINITIONS(-DHAVE_LIBXSLT)
        SET(EXTRA_LIBS ${EXTRA_LIBS} ${LIBXSLT_LIBRARIES})

=== plugin/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  cmake rules for eurephia - OpenVPN authentication plugin
 #
-#  GPLv2 only - Copyright (C) 2008 - 2010
+#  GPLv2 only - Copyright (C) 2008 - 2012
 #               David Sommerseth <dazo@users.sourceforge.net>
 #
 #  This program is free software; you can redistribute it and/or
@@ -96,7 +96,7 @@
 SET_TARGET_PROPERTIES(eurephia-auth PROPERTIES PREFIX "")
 
 # Link in libraries
-TARGET_LINK_LIBRARIES(eurephia-auth dl pthread rt crypto common)
+TARGET_LINK_LIBRARIES(eurephia-auth pthread rt crypto common)
 
 # Install rules
 INSTALL(TARGETS eurephia-auth  LIBRARY DESTINATION ${PLUGINDIR})

=== database/sqlite/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  cmake rules for eurephia - SQLite3 database driver
 #
-#  GPLv2 only - Copyright (C) 2008 - 2010
+#  GPLv2 only - Copyright (C) 2008 - 2012
 #               David Sommerseth <dazo@users.sourceforge.net>
 #
 #  This program is free software; you can redistribute it and/or
@@ -23,13 +23,15 @@
 INCLUDE(CheckLibraryExists) 
 
 # Parameters the SQLite3 driver needs
-SET(SQLITE3PREFIX "/etc/openvpn" CACHE STRING "Install prefix for the eurephia SQLite3 database")
+SET(SQLITE3PREFIX "/var/lib/eurephia" CACHE STRING "Install prefix for the eurephia SQLite3 database")
 
 #
 #  Check for the SQLite3 library
 #
 find_package(PkgConfig)
 pkg_search_module(SQLITE3 REQUIRED sqlite3)
+INCLUDE_DIRECTORIES(BEFORE ${SQLITE3_INCLUDE_DIRS})
+LINK_DIRECTORIES(${SQLITE3_LIBRARY_DIRS})
 
 FIND_PROGRAM(SQLITE3BIN sqlite3 /usr)
 IF(NOT SQLITE3BIN)
@@ -67,7 +69,7 @@
 # Build instructions
 #
 ADD_LIBRARY(edb-sqlite SHARED ${edb_sqlite_SRC})
-TARGET_LINK_LIBRARIES(edb-sqlite common)
+TARGET_LINK_LIBRARIES(edb-sqlite common ${SQLITE3_LIBRARIES})
 SET_TARGET_PROPERTIES( edb-sqlite PROPERTIES COMPILE_FLAGS -fPIC)
 
 IF(SQLITE3BIN)

=== debian/changelog ===
eurephia (1.1.0-6.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix ftbfs with GCC-10. (Closes: #957184)
    - Use fcommon with CFLAGS.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 30 Nov 2020 20:44:45 +0000

eurephia (1.1.0-6) unstable; urgency=medium

  * Make build reproducible. Thanks Chris Lamb for the patch!
    (Closes: #831353)

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Fri, 16 Sep 2016 09:38:26 +0200

eurephia (1.1.0-5) unstable; urgency=medium

  * Add -fPIC -std=gnu89 to CFLAGS. (Closes: #777845)

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Tue, 07 Jul 2015 17:14:38 +0200

eurephia (1.1.0-4) unstable; urgency=low

  * Add -ldl to LD_FLAGS. (Closes: #713598)

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Wed, 26 Jun 2013 13:09:51 +0200

eurephia (1.1.0-3) unstable; urgency=low

  * Upload to unstable.
  * Moved to dh.
  * Bumped Standards-Version to 3.9.4
  * Moved debian/compat to 9

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Wed, 05 Jun 2013 14:42:14 +0200

eurephia (1.1.0-2) unstable; urgency=low

  * Apply patches from upstream:
   - double-free.patch
    Fixed a double-free situation with dev-type is not obvious
   - sql-error-handling.patch
    Improve error handling if memory alloc fails for SQL query string

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Fri, 26 Oct 2012 13:26:08 +0200

eurephia (1.1.0-1) unstable; urgency=low

  * New upstream release.
  * Removed debian/patches/* (all applied upstream)

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Wed, 24 Oct 2012 14:58:09 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: net
 Priority: extra
 Maintainer: Alberto Gonzalez Iniesta <agi@inittab.org>
-Build-Depends: debhelper (>= 8), openvpn (>=2), cmake, libssl-dev, libxslt1-dev, libxml2-dev, libsqlite3-dev, pkg-config
-Standards-Version: 3.9.1
+Build-Depends: debhelper (>= 9), openvpn (>=2), cmake, libssl-dev, libxslt1-dev, libxml2-dev, libsqlite3-dev, pkg-config
+Standards-Version: 3.9.4
 Homepage: http://www.eurephia.net/
 
 Package: eurephia

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_configure:
	$(shell DEB_CFLAGS_MAINT_APPEND="-fPIC -std=gnu89 -fcommon" dpkg-buildflags --export=configure) ./configure --prefix /usr --plug-in --fw-iptables --db-sqlite3 --sqlite3-path /var/lib/eurephia --eurephiadm --openvpn-src /usr/include/openvpn
override_dh_auto_clean:
	rm -rf configure.log
	dh_auto_clean

override_dh_auto_install:
	dh_auto_install
	install -p -m 755 utils/eurephia_init $(CURDIR)/debian/eurephia/usr/bin/
	install -p -m 755 utils/eurephia_saltdecode $(CURDIR)/debian/eurephia/usr/bin/
	rm -f debian/eurephia/var/lib/eurephia/eurephiadb-template

## eurephia 1.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #  cmake rules for eurephia - main file
 #
-#  GPLv2 only - Copyright (C) 2008 - 2012
-#               David Sommerseth <dazo@users.sourceforge.net>
+#  GPLv2 only - Copyright (C) 2008 - 2019
+#               David Sommerseth <dazo@eurephia.org>
 #
 #  This program is free software; you can redistribute it and/or
 #  modify it under the terms of the GNU General Public License
@@ -18,7 +18,7 @@
 #  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 #
 PROJECT(eurephia C)
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 3.13)
 
 # Set the eurephia version
 ADD_DEFINITIONS(-DEUREPHIAVERSION="1.1.0")
@@ -120,6 +120,7 @@
 IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
         CHECK_LIBRARY_EXISTS(dl dlopen "" HAVE_DLOPEN)
         CHECK_LIBRARY_EXISTS(dl dlclose "" HAVE_DLCLOSE)
+        SET(EXTRA_LIBS ${EXTRA_LIBS} -ldl)
 ELSE(!${CMAKE_SYSTEM_NAME} MATCHES "Linux")
         CHECK_LIBRARY_EXISTS(c dlopen "" HAVE_DLOPEN)
         CHECK_LIBRARY_EXISTS(c dlclose "" HAVE_DLCLOSE)

=== common/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  cmake rules for eurephia - common static library
 #
-#  GPLv2 only - Copyright (C) 2008 - 2010
+#  GPLv2 only - Copyright (C) 2008 - 2012
 #               David Sommerseth <dazo@users.sourceforge.net>
 #
 #  This program is free software; you can redistribute it and/or
@@ -45,6 +45,7 @@
              eurephia_log.c
              eurephia_nullsafe.c
              eurephia_values.c
+             eurephia_cfgfile.c
              passwd.c
              randstr.c
              sha512.c

=== doxygen/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  cmake rules for eurephia - doxygen documentation
 #
-#  GPLv2 only - Copyright (C) 2009 - 2010
+#  GPLv2 only - Copyright (C) 2009 - 2012
 #               David Sommerseth <dazo@users.sourceforge.net>
 #
 #  This program is free software; you can redistribute it and/or

=== eurephiadm/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  cmake rules for eurephia - eurephiadm, console admin utility
 #
-#  GPLv2 only - Copyright (C) 2008 - 2010
+#  GPLv2 only - Copyright (C) 2008 - 2012
 #               David Sommerseth <dazo@users.sourceforge.net>
 #
 #  This program is free software; you can redistribute it and/or
@@ -31,6 +31,14 @@
         ADD_DEFINITIONS(-DFIREWALL)
 ENDIF(FIREWALL)
 
+ADD_CUSTOM_COMMAND(
+        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/buildinfo.h
+        COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/mk_buildinfo.sh
+        DEPENDS commands/buildinfo.c
+        COMMENT "Creating buildinfo.h"
+)
+SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES buildinfo.h)
+
 # Build rules for eurephiadm
 ADD_EXECUTABLE(eurephiadm
         eurephiadm.c
@@ -50,6 +58,8 @@
         commands/adminaccess.c
         commands/edit_config.c
         commands/fwprofiles.c
+        buildinfo.h
+        commands/buildinfo.c
         ../common/eurephiadb_session_common.c
 )
 
@@ -69,7 +79,7 @@
 
 # Link in the following dynamic libraries with eurephiadm.
 # ${EXTRA_LIBS} contains libxml2, libxslt and openssl library names
-TARGET_LINK_LIBRARIES(eurephiadm dl crypto common ${EXTRA_LIBS})
+TARGET_LINK_LIBRARIES(eurephiadm crypto common ${EXTRA_LIBS})
 
 # Install rules for eurephiadm
 INSTALL(TARGETS eurephiadm RUNTIME DESTINATION ${BINDIR})

=== utils/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  cmake rules for eurephia - utilities
 #
-#  GPLv2 only - Copyright (C) 2008 - 2010
+#  GPLv2 only - Copyright (C) 2008 - 2012
 #               David Sommerseth <dazo@users.sourceforge.net>
 #
 #  This program is free software; you can redistribute it and/or
@@ -40,8 +40,9 @@
                  ../eurephiadm/get_console_input.c
                  ../eurephiadm/argparser.c
                  ../eurephiadm/client_context.c
+                 ../eurephiadm/client_config.c
 		)
-  TARGET_LINK_LIBRARIES(eurephia_init dl crypto common ${EXTRA_LIBS})
+  TARGET_LINK_LIBRARIES(eurephia_init crypto common ${EXTRA_LIBS})
 
   # Define the saltdecode build
   ADD_EXECUTABLE(eurephia_saltdecode

=== xslt/eurephiadm/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  cmake rules for eurephia - XSLT templates for eurephiadm
 #
-#  GPLv2 only - Copyright (C) 2008 - 2010
+#  GPLv2 only - Copyright (C) 2008 - 2012
 #               David Sommerseth <dazo@users.sourceforge.net>
 #
 #  This program is free software; you can redistribute it and/or

=== plugin/firewall/iptables/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #  cmake rules for eurephia - iptables firewall driver
 #
-#  GPLv2 only - Copyright (C) 2008 - 2010
+#  GPLv2 only - Copyright (C) 2008 - 2012
 #               David Sommerseth <dazo@users.sourceforge.net>
 #
 #  This program is free software; you can redistribute it and/or

=== debian/changelog ===
eurephia (1.1.1-3) unstable; urgency=medium

  * QA upload.
  * Fix building with -Werror=implicit-function-declaration.
    (Closes: #1073320)
  * Switch from transitional pkg-config to pkgconf.
  * Declare Rules-Requires-Root: no.
  * Build verbosely.
  * Set locale to POSIX for reproducible timestamps.
  * Fix omission of CPPFLAGS.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 20 Jun 2024 09:36:49 +0200

eurephia (1.1.1-2) unstable; urgency=high

  * QA upload.
  * debian/rules: Disable parallel build to circumvent Make dependency
    bugs.

 -- Boyuan Yang <byang@debian.org>  Sat, 26 Nov 2022 16:10:24 -0500

eurephia (1.1.1-1) unstable; urgency=medium

  * QA upload.
  * New upstream version 1.1.1.
  * debian/: Apply wrap-and-sort -abst.
  * debian/control:
    + Bump Standards-Version to 4.6.1.
    + Bump debhelper compat to v13.
    + Fix Vcs-* fields.
  * debian/rules: Enable full hardening.
  * debian/watch: Fix monitoring script.
  * debian/copyright: Minor update.
  * debian/patches: Drop patches merged upstream.
  * debian/patches: Add patch to skip RPATH (lintian).

 -- Boyuan Yang <byang@debian.org>  Wed, 23 Nov 2022 14:14:43 -0500

eurephia (1.1.0-7) unstable; urgency=medium

  * Orphan package. Set maintainer to QA.

 -- Alberto Gonzalez Iniesta <agi@inittab.org>  Sat, 24 Sep 2022 12:59:17 +0200

=== debian/control ===
Source: eurephia
Section: net
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libsqlite3-dev,
 libssl-dev,
 libxml2-dev,
 libxslt1-dev,
 openvpn (>=2),
 pkgconf,
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: http://www.eurephia.net/
Vcs-Git: https://salsa.debian.org/debian/eurephia.git
Vcs-Browser: https://salsa.debian.org/debian/eurephia

Package: eurephia
Architecture: any
Depends:
 openvpn (>=2),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 sqlite3,
Description: flexible OpenVPN authentication module
 This plug-in enhances OpenVPN by adding user name and password authentication.
 An eurephia user account is a combination of minimum one OpenVPN SSL
 certificate and a user name with a password assigned. It is also possible to
 setup several eurephia user names to use a shared OpenVPN certificate.
 .
 In addition, eurephia will blacklist IP addresses, certificates and user names
 on too many failed attempts and it supports dynamic update of iptables rules
 which restricts network access per connection.
 .
 All information is stored in a database and all changes to the accounts will
 be effective immediately. At the moment eurephia supports the SQLite database.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND = -fPIC -std=gnu89 -fcommon

include /usr/share/dpkg/buildflags.mk

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
export VERBOSE = 1
endif

%:
	dh $@ --no-parallel

override_dh_auto_configure:
	CFLAGS="$(CFLAGS) $(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" ./configure --prefix /usr --plug-in --fw-iptables --db-sqlite3 --sqlite3-path /var/lib/eurephia --eurephiadm --openvpn-src /usr/include/openvpn

execute_before_dh_auto_clean:
	rm -rf configure.log

execute_after_dh_auto_install:
	install -p -m 755 utils/eurephia_init $(CURDIR)/debian/eurephia/usr/bin/
	install -p -m 755 utils/eurephia_saltdecode $(CURDIR)/debian/eurephia/usr/bin/
	rm -f debian/eurephia/var/lib/eurephia/eurephiadb-template

=== debian/watch ===
version=4
opts="" \
 https://sf.net/eurephia/ eurephia-@ANY_VERSION@@ARCHIVE_EXT@
